#define TITLE "DUMP " __DATE__ " " __TIME__



#include "mzprint.h"
#include "ndsetc.h"
#include "cardme.h"
#include "mpcfio.h"

#define WT wait(10)


int header_cmp(unsigned char *buf1,unsigned char *buf2)
{
	int i;
	for (i=0;i<16;i++) {
		if (buf1[i]!=buf2[i]) { return -1; }
	}
	return 0;
}

void dumpeep(void)
{
	u32 i,j,k=0;
	u32 ad=0x10;
	u8 *a;
	char msg[128];
#define FILESZMAX (8*1024)// (8*1024)  //(256*1024)
static	char dumpbuf[FILESZMAX];
#define TESTSZ (256)

static int lt=4;

char *eept[]={"0?","1","2","3","UNNOWN"};

	int fs=0;
	int cs=0;
	u32 *dumpbufp=NULL;

	u32 x;
	u32 top;


	cls(0);

	lt=cardmeGetType();
	if(lt<=0)
	{
		locate(0,2);
		print("DS SAVE TYPE ERROR\n");
		nkeywait();
		keywait();
		goto deep_end;
	}
	cs=cardmeSize(lt);
	fs=512*1024;
	dumpbufp=(u32 *)malloc(fs);
	if(dumpbufp==NULL)
	{
		fs=FILESZMAX ;// cardmeSize(lt);
		x=(u32)dumpbuf;
		top=(u32)dumpbuf;
	}
	else
	{
		x=(u32)dumpbufp;
		top=(u32)dumpbufp;
	}

	for(;;)
	{

		cls(0);

			locate(0,0);

				print(TITLE);
		


		WAIT_CR &= ~0x0880;	// DS Card access ARM9:bit11=0   GBA Cart access ARM9:bit7=0




		locate(0,2);
		print("DS SAVE TYPE IS ");
		print(eept[lt]);
		print("\n");



		mem2clear((uint32 *) top,0x00000000,FILESZMAX);
		wait(1);

		cardmeReadEeprom(0,(uint8 *)top,fs,lt);		// 

		
			locate(0,3);
				sprintf(msg,"SIZE:%d bytes ($%06X)",cs,cs);
				print(msg);
		
		for(;;)
		{
			locate(0,4);
				
				k=x;
				sprintf(msg,"%08X-",k-top);
				print(msg);
			for(j=0;j<0x10;j++)
			{
				k=x+j*0x8;
				locate(0,j+5);
				sprintf(msg,"%04X:",(k-top)%0x10000);
				print(msg);
				for(i=0;i<0x8;i++)
				{
					if(k+i-top>=fs)
					{
					print("--");
					}
					else
					{
					a=(u8 *)k+i;
					sprintf(msg,"%02X",*a);
					print(msg);
					}
				}
				for(i=0;i<0x8;i++)
				{
					
					locate(22+i,j+5);
					if(k+i-top>=fs)
					{
					print(" ");
					}
					else
					{

						a=(u8 *)k+i;

						if(*a>=0x20 && *a<0x80)
						{
						msg[0]=*a;
						}
						else
						{
						msg[0]='.';
						}
						msg[1]=0;
						print(msg);
					}
				}
			}
		print("\n\nOK\n");
			keywait();
			
			if(isCANCEL)
			{
				nkeywait();
				goto deep_end;
			//	return;
			//	break;
			}
			else
			if(isBREAK)
			{
				goto deep_end;
			//	return;
			}
			if(isCU)
			{
				x-=ad;
			}
			if(isCD)
			{
				x+=ad;
			}
			if(isCR)
			{
				x+=ad*8;
			}
			if(isCL)
			{
				x-=ad*8;
			}
				if(x<top)x=top;
			//	if(x-top>fs+0x80*1)x=top+fs+0x80*1;
			//	if(x-top>fs+0x80/2)x=top+fs+0x80/2;
				if(x-top>fs )x=top+fs ;
			if(isSHIFT)
			{
				//wait(0);
				continue;
			}

			wait(10);

		}
	}

	deep_end:
	
	if(dumpbufp!=NULL)
	{
		free(dumpbufp);
	}

}



