
#include "mzprint.h"
#include "ndsetc.h"
#include "cardme.h"
#include "dbg.h"
#include "fileselect.h"
#include "savename.h"

#include "mpcfio.h"

void	eep_save(void);
void	eep_load(void);
void	eep_test(void);
void	eep_init(void);

void	eep_save2(void);
void	eep_load2(void);
#define BUN (32)

#define data eeptool_data
u8 data[256*1024/BUN];

int eep_savefile(char *fn,char *mode)
{
	FILE *fp;
	int tp;
	int sz;
	int i;
//	u8 *data;
	tp=cardmeGetType();
	if(tp<=0)
	{
		print("DS SAVE TYPE ERROR\n");
		return -1;
	}
	

	if(! InitFiles())
	{
		print("CF NOT READY\n");
		return -1;
	}
	
//	fp=fopen(fn,"w");
	fp=fopen(fn,mode);
	
	if(fp==NULL)
	{
		print("FOPEN ERROR\n");
		return -1;
	}
	sz=cardmeSize(tp);

	locate(0,12);
	//     12345678901234567890123456789012
	print("-------+-------+-------+-------+");
	locate(0,13);
	print("0%    25%     50%     75%    100");
	for(i=0;i<BUN;i++)
	{
	locate(i,11);
	cardmeReadEeprom(i*sz/BUN,data,sz/BUN,tp);
	fwrite(data, sz/BUN,1, fp);
	print("#");
	}
	fclose(fp);
	FreeFiles();

	locate(0,14);
	return 0;

}

int eep_loadfile(char *fn)
{
	char buff[80];
	FILE *fp;
	int tp;
	int sz,rs;
	int i;


	
	tp=cardmeGetType();

	sprintf(buff,"TYPE=%d\n",tp);print(buff);

	if(tp<=0)
	{
		print("DS SAVE TYPE ERROR\n");
		return -1;
	}
	if(! InitFiles())
	{
		print("CF NOT READY\n");
		FreeFiles();
		return -1;
	}
	
	fp=fopen(fn,"r");
	
	if(fp==NULL)
	{
		print("FOPEN ERROR\n");
		return -1;
	}
	sz=cardmeSize(tp);

/*
	
	if(rs != sz)
	{
		sprintf(buff,"memory size=%dbytes\n",sz);print(buff);
		sprintf(buff,"file   size=%dbytes\n",rs);print(buff);
		print("File size is not in agreement.\nƺ?̧ɻ޶޲Ͻ\n");
			goto eep_loadfile_err;
	//	return -1;
	}
*/

	if(tp==3)	//	TYPE 3 ͏Kv
	{
		locate(0,8);
		print("FLASH MEMORY erase ... ");
		if(cardmeChipErase()<0)
		{
			// fail
			print("NG");
		//	nkeywait();
		//	keywait();
			locate(0,13);
			goto eep_loadfile_err;
		//	return -1;

		}
		else
		{
			// ok
			print("OK");
		}
	}

	locate(0,12);
	//     12345678901234567890123456789012
	print("-------+-------+-------+-------+");
	locate(0,13);
	print("0%    25%     50%     75%    100");
	for(i=0;i<BUN;i++)
	{
	locate(i,11);
	rs=fread(data,sz/BUN,1, fp);
	cardmeWriteEeprom(i*sz/BUN,data,sz/BUN,tp);


	print("#");
	}

	fclose(fp);
	FreeFiles();
	locate(0,13);
	return 0;
	
	eep_loadfile_err:
	fclose(fp);
	FreeFiles();
	return -1;

}

int eep_dspinfo(void)
{
	int tp;
	int otp=0;
	int sz;
//	int gameno=-1;
	char buff[80];
		char id[8+1];
	
		for(;;)
		{
			keywaitn(30);
			if(isEXE)
			{
			//	break;
				return 0;
			}
			if(isCANCEL)
			{
				return -1;
			}
				tp=cardmeGetType();
				if(tp!=otp)
				{
					sz=cardmeSize(tp);
					locate(0,4);
					sprintf(buff,"TYPE=%-2d SIZE=%dbyte ",tp,sz);print(buff);
					if(tp>0)
					{
						cardmeReadEeprom(0,data,4096,tp);
							if(getgameid((char *)data,4096,id)>=0)
							{
								sprintf(buff,"id=%4s ",id);print(buff);
							}
							else
							{
								print("id=     ");
							}
							locate(0,5);
							
							sprintf(buff,"%s\n",getgamename((char *)data,4096,1));print(buff);
							sprintf(buff,"%s",getgamename((char *)data,4096,0));print(buff);
					}
					else
					{
					//         id=1234 name=12345678
						print("                      \n");
					//         1234567890123456
						print("                      \n");
					//         1234567890123456
						print("                      \n");
					}
					otp=tp;
					wait(30);
				}
			wait(1);
		}

}

void	eep_save(void)
{
	int ret=0;
	int tp;
//		char id[8+1];
//	char *fn="FILE.SAV";
//	char buff[80];
	char fn[256];
	cls(0);
	locate(0,0);
	print("BACKUP  / DS SAVE -> SAVE FILE\n");
	locate(0,2);
	print("PLEASE INSERT DS CARD and PUSH A\n");
	nkeywait();
	
	//
	if(eep_dspinfo()<0)return;

	nkeywait();


	{
		tm t;
//		char id[8+1];

		time2(&t);


				tp=cardmeGetType();
		cardmeReadEeprom(0,data,4096,tp);
	sprintf(fn,"%s_%02d%02d_%02d%02d%02d.SAV",
		getgamename((char *)data,4096,1),
		t.tm_mon ,
		t.tm_mday ,
		t.tm_hour ,
		t.tm_min ,
		t.tm_sec 
		); 
	}
	
	locate(0,8);
	print("BACKUP FILE NAME IS ...\n>");
	print(fn);

	print(".\n");
	
	//	t@Cɕۑ鏈
	ret=eep_savefile(fn,"w");
	//^[lĎs/
	if(ret<0)
	{
		print("NG\nFAILD BACKUP.");
	}
	else
	{
		print("OK\nSUCCESS.");
	}
	
	keywait();
	nkeywait();

}

void	eep_load(void)
{

	int ret=0;
	char *fn="FILE.SAV";
//	int tp;
//	int sz;
//	char id[8+1];
	char buff[80];
	
	cls(0);
	locate(0,0);
	print("RESTORE / DS SAVE <- SAVE FILE\n");
	locate(0,2);
	print("PLEASE INSERT DS CARD and PUSH A\n");
	nkeywait();

	//
	if(eep_dspinfo()<0)return;

	nkeywait();

	
	fn=fileselect(".SAV");

	if(fn==NULL)
	{
		return;
	}

	cls(0);
	locate(0,0);
	print("RESTORE / DS SAVE <- SAVE FILE\n");
	locate(0,2);
	sprintf(buff,"DS CARD:name=%s\n",getgamename((char *)data,4096,1));print(buff);
	sprintf(buff,"DS CARD:%s\n",getgamename((char *)data,4096,0));print(buff);

	locate(0,5);


	print("RESTORE FILE NAME IS ...\n>");

	print(fn);
	print(".\n");
	



	print("OK ? PUSH [START]\n");


	nkeywait();
		for(;;)
		{
			keywait();
			if(isPAUSE)
			{
				break;
			}
			if(isCANCEL)
			{
				return;
			}
			wait(1);
		}
	nkeywait();



	
	//	t@C߂
	ret=eep_loadfile(fn);
	//^[lĎs/
	if(ret<0)
	{
		print("NG\nFAILD RESTORE.");
	}
	else
	{
		print("OK\nSUCCESS.");
	}
	
	keywait();
	nkeywait();


}

void	eep_test(void)
{
#define HEADSZ (8)
	char buff[80];
	char buff2[80];
	u8 wk[HEADSZ];
	int tp;
	int sz;
	int i;
//	int id0,id1;
	int addr=0;
	u8 cmd=0;
	int ret;
	int logf=0;
	for(;;)
	{
		cls(0);
		


		print("TEST    / ANALYZE for debug\n");
		
		//
		nkeywait();

		print("START:ANALYZE output log\n");
		print("A:ANALYZE display only\n");
		print("B:cancel\n");

		keywait();
		if(isPAUSE)
		{
			logf=1;
			break;
		}
		else if(isCANCEL)
		{
			nkeywait();
			return;
		}
		else if(! isEXE)
		{
			continue;
		}
		break;
	}
#define dl(x) {print(x);print("\n");if(logf==1){log(x);}}
#define dlb(x,size) {if(logf==1){logb(x,size);}}

	dl("# eeprom check ########");
		tp=cardmeGetType();
		
		sprintf(buff,"TYPE=%d",tp);dl(buff);


		sz=cardmeSize(tp);
		sprintf(buff,"SIZE=%d",sz);dl(buff);
		
		for(tp=1;tp<=3;tp++)
		{
			sprintf(buff,"TYPE %d READ TEST (ADDR:$%06X)",tp,addr);dl(buff);
			strcpy(buff,"1st:");
			cardmeReadEeprom(addr,wk,HEADSZ,tp);
			for(i=0;i<HEADSZ;i++)
			{
			sprintf(buff2,"%02X",wk[i]);
			strcat(buff,buff2);
			}
			dl(buff);
			

			strcpy(buff,"2nd:  ");
			addr+=1;
			cardmeReadEeprom(addr,wk,HEADSZ,tp);
			for(i=0;i<HEADSZ;i++)
			{
			sprintf(buff2,"%02X",wk[i]);
			strcat(buff,buff2);
			}
			addr--;
			dl(buff);
		}

		cmd=0x00;
		ret=cardmeCMD(cmd,0);
		sprintf(buff,"CMD:%02X = %02X",cmd,ret);dl(buff);
		cmd=0x03;
		ret=cardmeCMD(cmd,0);
		sprintf(buff,"CMD:%02X = %02X",cmd,ret);dl(buff);
		cmd=0x05;
		ret=cardmeCMD(cmd,0);
		sprintf(buff,"CMD:%02X = %02X",cmd,ret);dl(buff);

		cmd=0x07;
		ret=cardmeCMD(cmd,0);
		if(ret!=0xFF)
		{
		sprintf(buff,"CMD:%02X = %02X",cmd,ret);dl(buff);
		}

		cmd=0x08;
		ret=cardmeCMD(cmd,0);
		if(ret!=0xFF)
		{
		sprintf(buff,"CMD:%02X = %02X",cmd,ret);dl(buff);
		}

		cmd=0x9F;
		ret=cardmeCMD(cmd,0);
		sprintf(buff,"CMD:%02X = %02X",cmd,ret);dl(buff);
		
	for(i=0x0b;i<=0xC6;i++)
	{
		cmd=i;
		ret=cardmeCMD(cmd,0);
		if(ret!=0xFF)
		{
		sprintf(buff,"CMD:%02X = %02X",cmd,ret);dl(buff);
		}

	}
	for(i=0xC8;i<=0xD7;i++)
	{
		cmd=i;
		ret=cardmeCMD(cmd,0);
		if(ret!=0xFF)
		{
		sprintf(buff,"CMD:%02X = %02X",cmd,ret);dl(buff);
		}

	}
	for(i=0xD9;i<=0xFF;i++)
	{
		cmd=i;
		ret=cardmeCMD(cmd,0);
		if(ret!=0xFF)
		{
		sprintf(buff,"CMD:%02X = %02X",cmd,ret);dl(buff);
		}
	}


	//
	nkeywait();
	print("CONTINUE...\n");
	keywait();

	cls(0);

	//	Q[̔
	dl("# save data check ########");
	tp=cardmeGetType();
	if(tp>0)
	{
		char id[8+1];
		sprintf(buff,"TYPE=%d",tp);dl(buff);
		cardmeReadEeprom(0,data,4096,tp);
		
		if(getgameid((char *)data,4096,id)>=0)
		{
			sprintf(buff,"gameid=%s",id);dl(buff);
		}
		else
		{
			dl("gameid=(unknown)");
		}
		
		sprintf(buff,"gamename[J]=%s",getgamename((char *)data,4096,0));dl(buff);
		sprintf(buff,"gamename[E]=%s",getgamename((char *)data,4096,1));dl(buff);
	}
	//	J[hID̒
	dl("# card check ########");
	{
		int cdid=cardReadID(0);
		sprintf(buff,"cardReadID=%08X",cdid);dl(buff);
		
		//cardReadHeader
	//	cardReadHeader(data);
	//	cardmeReadHeader(data);
	//	cardRead00(0, (uint32 *)header, 512, 0xA93F1FFF);
		cardRead00(0, (uint32 *)data, 512, 0xA93F1FFF);

	//	dl("cardmeReadHeader (32bytes out)");
		dl("cardRead00(0, (uint32 *)data, 512, 0xA93F1FFF) (32bytes out)");
		
		buff[0]=0;
		for(i=0;i<32;i++)
		{
		sprintf(buff2,"%02X",wk[i]);
		strcat(buff,buff2);
		}
		dl(buff);
		dlb((char *)data,512);

	}
	//	fBXNI/F
	{
		char *mes0="";
		switch(disc_if())
		{
			case DISC_IF_NONE:
				mes0="NONE";
			break;
			case DISC_IF_SCCF:
				mes0="Super Card CF";
			break;
			case DISC_IF_SCSD:
				mes0="Super Card SD";
			break;
			case DISC_IF_MPCF:
				mes0="GBAMP CF";
			break;
			case DISC_IF_M3CF:
				mes0="M3 CF";
			break;
//			case DISC_IF_M3SD:
//				mes0="M3 SD";
			break;
		}
		sprintf(buff,"DISC I/F:%s",mes0);
		dl(buff);
	}
	
	dl("========");
	nkeywait();
	print("OK\n");
	keywait();
	
}

void	eep_init(void)
{
	int tp;
	int sz;
	int i;

//	u8 *data;

	cls(0);
	


	print("FORMAT  / INITIALIZE DS SAVE\n");


	nkeywait();
	locate(0,2);
	print("Sure ?\n");
	print("start  : SELECT + START\n");
	print("cansel : B\n");
	for(;;)
	{
		keywait();
		
			if(isPAUSE && isSHIFT)
			{
			nkeywait();
				break;
			}
			if(isCANCEL)
			{
				nkeywait();
				return;
			}
			wait(1);
	}


	tp=cardmeGetType();
	if(tp<=0)
	{
		print("DS SAVE TYPE ERROR\n");
		nkeywait();
		keywait();
		return;
	}


	if(tp==3)	//	TYPE 3 ͏̂
	{
		locate(0,8);
		print("FLASH MEMORY erase ... ");
		if(cardmeChipErase()<0)
		{
			// fail
			print("NG");
			nkeywait();
			keywait();
		}
		else
		{
			// ok
			print("OK");
			nkeywait();
			keywait();
		}
		return;
	}
	
	
	sz=cardmeSize(tp);
	

	memset(data,0xFF,sz/BUN);
//	strcpy((char *)data,"FORMAT by NDS EEPROM TOOL "  __DATE__ " " __TIME__ "  ");


	wait(1);


	locate(0,11);
	//     12345678901234567890123456789012
	print("-------+-------+-------+-------+");
	locate(0,12);
	print("0%    25%     50%     75%    100");
	for(i=0;i<BUN;i++)
	{
	locate(i,10);

	sprintf((char *)data,"$%06X",i*sz/BUN);
	cardmeWriteEeprom(i*sz/BUN,data,sz/BUN,tp);
	print("#");

	}


	locate(0,13);
	print("OK\n");
	nkeywait();
	keywait();

}





