

#include "../../common/nds_compati.h"
#include "ndsetc.h"
#include "mzprint.h"
#include "cardme.h"

int sramRead(u32 addr,u8 *data,u32 len)
{
	u32 i;
	u8 dum=0;
	if((addr + len > 64*1024)||(addr  >= 64*1024))
	{
		return -1;
	}
	WAIT_CR &= ~0x0880;	// DS Card access ARM9:bit11=0   GBA Cart access ARM9:bit7=0
	dum+=SRAM[0];	//	_~[ǂݍ
	dum-=SRAM[0];	//	_~[ǂݍ
	dum+=SRAM[0];	//	_~[ǂݍ


	for(i=0;i<len;i++)
	{
		data[i]=(u8)SRAM[addr+i];
	}
	return 0;

}

int sramWrite(u32 addr,u8 *data,u32 len)
{
	u32 i;
	u8 dum=0;
	if((addr + len > 64*1024)||(addr  >= 64*1024))
	{
		return -1;
	}
	WAIT_CR &= ~0x0880;	// DS Card access ARM9:bit11=0   GBA Cart access ARM9:bit7=0
	dum+=SRAM[0];	//	_~[ǂݍ
	dum-=SRAM[0];	//	_~[ǂݍ
	dum+=SRAM[0];	//	_~[ǂݍ

	for(i=0;i<len;i++)
	{
		SRAM[addr+i]=data[i];
	}

	return 0;

}


#define HEADSZ (8)
#define data sramtool_data
static	u8 data[64*1024];

void eep_se_print(u8 *data,int tp)
{
	int i;
	char buff[80];
		locate(0,8);
		//     12345678
		print("DS SAVE:");

	cardmeReadEeprom(0,data,HEADSZ,tp);
	for(i=0;i<HEADSZ;i++)
	{
		char wk[2];
		wk[0]=data[i];
		wk[1]=0;
		locate(8+i,8);
		print(wk);
		locate(i*2,9);
		sprintf(buff,"%02X",(int)data[i]);
		print(buff);
	}

		locate(0,10);
		//     12345678
		print("  SRAM:");
	sramRead(0,data,HEADSZ);
	for(i=0;i<HEADSZ;i++)
	{
		char wk[2];
		wk[0]=data[i];
		wk[1]=0;
		locate(8+i,10);
		print(wk);
		locate(i*2,11);
		sprintf(buff,"%02X",(int)data[i]);
		print(buff);
	}
}

void	eep_save2(void)
{
	int ret=0;
	int tp;
	int sz;
//	int i;
	char buff[80];
//	u8 data[64*1024];


	cls(0);
	locate(0,0);
	print("BACKUP2 / DS SAVE -> GBA SRAM\n");
	locate(0,2);
	print("PLEASE INSERT\n1:DS CARD(EEPROM)\n2:GBA CART(SRAM)\n3:PUSH [A].\n");
	nkeywait();
		for(;;)
		{
			keywait();
			if(isEXE)
			{
				break;
			}
			if(isCANCEL)
			{
				return;
			}
			wait(1);
		}
	nkeywait();
	
	//	EEPROM TYPE
	
	tp=cardmeGetType();

	sprintf(buff,"TYPE=%d\n",tp);print(buff);

	if(tp<=0)
	{
		print("DS SAVE TYPE ERROR\n");
		keywait();
		nkeywait();
		return ;
	}

	switch(tp)
	{
		case 1:
		case 2:
			break;
		case 3:
		default:
			print("SORRY,CAN NOT SUPPORT TYPE.\n"
			"ӳܹŲ޶ޤòŲš\n"
			);
			keywait();
			nkeywait();
			return ;
	}
	
	//	SRAMEEPROM̒g\
	eep_se_print(data,tp);
		locate(0,12);

	print("IT'S OK? [START]\n");

		for(;;)
		{
			keywait();
			if(isPAUSE)
			{
				break;
			}
			if(isCANCEL)
			{
				return;
			}
			wait(1);
		}
	nkeywait();

	sz=cardmeSize(tp);
	cardmeReadEeprom(0,data,sz,tp);
	ret=sramWrite(0,data,sz);
		if(ret<0)
		{
			// fail
			print("NG");
		}
		else
		{
			// ok
			print("OK");
		}
	
	keywait();
	nkeywait();

}


void	eep_load2(void)
{
	int ret=0;
	int tp;
	int sz;
//	int i;
	char buff[80];
//	u8 data[64*1024];


	cls(0);
	locate(0,0);//             SRAM
	print("RESTORE2/ DS SAVE <- GBA SRAM\n");
	locate(0,2);
	print("PLEASE INSERT\n1:DS CARD(EEPROM)\n2:GBA CART(SRAM)\n3:PUSH [A].\n");
	nkeywait();
		for(;;)
		{
			keywait();
			if(isEXE)
			{
				break;
			}
			if(isCANCEL)
			{
				return;
			}
			wait(1);
		}
	nkeywait();
	
	//	EEPROM TYPE
	
	tp=cardmeGetType();

	sprintf(buff,"TYPE=%d\n",tp);print(buff);

	if(tp<=0)
	{
		print("DS SAVE TYPE ERROR\n");
		keywait();
		nkeywait();
		return ;
	}

	switch(tp)
	{
		case 1:
		case 2:
			break;
		case 3:
		default:
			print("SORRY,CAN NOT SUPPORT TYPE.\n"
			"ӳܹŲ޶ޤòŲš\n"
			);
			keywait();
			nkeywait();
			return ;
	}
	
	//	SRAMEEPROM̒g\
	eep_se_print(data,tp);
		locate(0,12);


	print("IT'S OK? [START]\n");

		for(;;)
		{
			keywait();
			if(isPAUSE)
			{
				break;
			}
			if(isCANCEL)
			{
				return;
			}
			wait(1);
		}
	nkeywait();

	sz=cardmeSize(tp);
	ret=sramRead(0,data,sz);
		if(ret<0)
		{
			// fail
			print("NG");
			keywait();
			nkeywait();
			return;
		}

	cardmeWriteEeprom(0,data,sz,tp);

	print("OK");
	
	keywait();
	nkeywait();
}

